package provide image 0.1

::itcl::class Image {
    # html file to be generated.
    public variable htmlfile
    # Image file name.
    private variable oldfilename ""
    public variable filename "" {
	if { $oldfilename != "" && $filename != $oldfilename } {
	    if { [catch {
		file rename $oldfilename $filename
	    } err] } {
		error "$err"
	    }
	    set fileroot [file root $filename]
	    set htmlfile ${fileroot}.html
	    set thumbnail [file join thumbs $filename]
	}
	set oldfilename $filename
    }
    # Image title.
    public variable title
    # Image caption.
    public variable caption
    # Keyword list.
    public variable keywords
    # Thumbnail image name - could this be its own object?
    public variable thumbnail
    # Thumbnail scale.
    public variable thumbnailscale

    constructor {} {
	set keywords ""
	set thumbnail ""
	set thumbnailscale 1
	set caption ""
    }
    destructor {}

    public method fromfile {fl} {
	set fileroot [file root $fl]
	set htmlfile ${fileroot}.html
	set thumbnail [file join thumbs $fl]
	set title $fileroot
	set filename $fl
	set oldfilename $fl
	set caption $fileroot
    }
}
