# manager.tcl -- album manager to keep track of disparate photo collections.

package provide manager 0.1

lappend auto_path [file join [file dirname [info script]]]

package require Itcl
package require xml
package require xml::c

package require album

::itcl::class Manager {
    public variable collections {}
    public variable directory

    constructor {args} {
	eval configure $args
    }

    destructor {}

    public method lookup

    public method addcollection {c} {
	lappend collections $c
    }

    public method writexml { xmlfile } {

	set f [open $xmlfile "w"]
	puts $f "<?xml version=\"1.0\"?>"
	puts $f "<album>"
	foreach c $collections {
	    set location [file dirname [$c cget -xmlfile]]
	    puts $f "<collection location=\"$location\"></collection>"
	    $c writexml
	}
	puts $f "</album>"
	close $f
    }

    public method readxml { file } {
	set fl [open $file]
	set data [read $fl]
	close $fl

	set parser [::xml::parser \
			-elementstartcommand [list $this element start] \
			-elementendcommand [list $this element end] \
			-characterdatacommand [list $this pcdata] \
			-final 1]

	$parser parse $data
    }

    public method element {tag name {attrs {}}} {
	array set attrhash $attrs
	if { $tag == "start" } {
	    switch -exact $name {
		"collection" {
		    set location $attrhash(location)
		    set album [namespace current]::[Album \#auto]
		    $album getxml [file join $location collection.xml]
		    lappend collections $album
		}
	    }
	} elseif { $tag == "end" } {
	    switch -exact $name {
		"collection" {
		}
	    }
	}
    }

    public method pcdata { data } {

    }

}

#set m [Manager \#auto]
#$m readxml /home/davidw/collection.xml
