# thumbnails.tcl -- generate thumbnails from images.
# $Id: thumbnails.tcl,v 1.4 2004/09/21 09:59:23 davidw Exp $

set auto_path "[file dir [info script]] $auto_path"

package provide thumbnails 0.1

package require magick

namespace eval thumbnails {
    set maxw 100
    set maxh 100
    set scalefactor .2
}

# thumbnails::makethumb --
#
#	Make thumbnail from image.
#
# Arguments:
#	filename - file to make thumbnail from.
#	thumbname - name of the thumbnail file.
#
# Side Effects:
#	None.
#
# Results:
#	None.

proc thumbnails::makethumb {filename thumbname} {
    variable maxw
    variable maxh
    set img [magick create wand src]
    $img ReadImage $filename

    set h [$img height]
    set w [$img width]
    set hdiff [expr {$h - $maxh}]
    set wdiff [expr {$w - $maxw}]
     if { $hdiff > $wdiff } {
	 set scale [expr {double($maxh) / double($h)}]
     } else {
	 set scale [expr {double($maxw) / double($w)}]
     }
    $img scale [expr {int($w * $scale)}] [expr {int($h * $scale)}]
    $img WriteImage $thumbname
    magick delete src
}
